theory MyList
imports Main
begin

datatype 'a mylist =  Mt 
                   | Cons 'a "'a mylist"

fun
  len :: "'a mylist=> nat"
where
   "len Mt = 0"
 | "len (Cons x xs) = 1+ len xs"
                   
fun 
  cat :: "'a mylist=> 'a mylist=> 'a mylist"     (infix "@@" 55)
where
   "cat Mt ys = ys"
 | "cat (Cons x xs) ys = Cons x (cat xs ys)"

lemma mt_unit_r: "xs @@ Mt= xs"
  apply (induct "xs", simp+)
  done

lemma cat_assoc: "(xs @@ ys) @@ zs = xs @@ (ys @@ zs)"
  apply (induct "xs")
  apply (simp)+
  done
  
ML_val{* @{thm mylist.induct} *} 
 
lemma length_cat: "len (xs @@ ys)= len xs+ len ys"
  apply (induct "xs")
  apply (simp+)
  done

fun rev :: "'a mylist => 'a mylist"
where
   "rev Mt = Mt"
 | "rev (Cons x xs) = rev xs @@ Cons x Mt"

lemma rev_cat: "rev (xs @@ ys)= rev ys @@ rev xs"
  apply (induct "xs")
  apply (simp add: mt_unit_r cat_assoc)+
  done
  
lemma rev_idem: "rev o rev = id"
  apply (rule ext, simp)
  apply (induct_tac "x")
  apply (simp add: rev_cat)+
  done
  
end
